Summary: xterm terminal emulator for the X Window System
Name:    xterm
Version: 215
Release: 5%{?dist}
URL:     http://dickey.his.com/xterm
License: MIT
Group:   User Interface/X
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

Source0: ftp://invisible-island.net/xterm/%{name}-%{version}.tgz
#Source1: ftp://invisible-island.net/xterm/ctlseqs.txt.gz
#         ^-  now shipped in upstream source tarball
Source2: ftp://invisible-island.net/xterm/UnicodeData-Latest.txt.gz
Source3: ftp://invisible-island.net/xterm/16colors.txt

Patch0: xterm-can-2003-0063.patch
Patch1: xterm-resources-redhat.patch
Patch2: xterm-179-ppc-fix-bug-101472.patch
Patch4: xterm-206-appsdir.patch
Patch5: xterm-207-freetype.patch
Patch6: xterm-207-eightBitInput_false.patch
Patch7: xterm-209-redhat-resources.patch
Patch8: xterm-208-root-grab-console.patch
Patch9: xterm-209-bz182382.patch
Patch10: xterm-209-bz183993.patch
Patch11: xterm-211-bz186094.patch
Patch12: xterm-212-bz186935.patch
Patch13: xterm-212-redhat-resources.patch
Patch14: xterm-212-man-page_paths.patch
Patch15: xterm-213-bz189161.patch
Patch16: xterm-215-tcsegfault.patch
Patch17: xterm-215-setegid.patch

BuildRequires: pkgconfig
BuildRequires: libXft-devel
BuildRequires: freetype-devel
BuildRequires: libXrender-devel
BuildRequires: libXaw-devel
BuildRequires: libXmu-devel
BuildRequires: libXext-devel
BuildRequires: libXt-devel
BuildRequires: libSM-devel
BuildRequires: libICE-devel
BuildRequires: libX11-devel
BuildRequires: libXpm-devel
BuildRequires: libtermcap-devel
BuildRequires: fontconfig-devel
BuildRequires: expat-devel
BuildRequires: zlib-devel
BuildRequires: libtermcap-devel
BuildRequires: libutempter-devel

%{?!DEBUGINFO:     %define DEBUGINFO    1}
%{?!enable_trace:  %define enable_trace 0}
%if !%{DEBUGINFO}
%define debug_package %{nil}
%endif

%define x11_app_defaults_dir %(pkg-config --variable appdefaultdir xt)

%{?!_with_256_color: %define _with_256_color 1}
%{?!_with_tek4014: %define _with_tek4014 1}

%description
The xterm program is a terminal emulator for the X Window System. It
provides DEC VT102 and Tektronix 4014 compatible terminals for
programs that can't use the window system directly.

%prep
%setup -q
# The xterm source code used to decompress with all of the files read-only,
# but appears to be fixed now
#chmod -R u+w .
%patch0 -p0 -b .can-2003-0063
#%patch1 -p1 -b .resources-redhat
%patch4 -p1 -b .appsdir
#%patch5 -p1 -b .freetype
#^- now fixed upstream in 208
#%patch6 -p1 -b .eightBitInput_false
#%patch7 -p1 -b .redhat-resources
#      ^- patch now in patch13
%patch8 -p1 -b .root-grab-console
#%patch9 -p1 -b .bz182382
#      ^- patch now upstream
#%patch10 -p1 -b .bz183993
#      ^- patch now upstream
#%patch11 -p1 -b .bz186094
#      ^- patch now in redhat-resources
#%patch12 -p1 -b .bz186935
#      ^- patch now upstream
%patch13 -p1 -b .redhat-resources
%patch14 -p1 -b .man-page_paths
%patch15 -p1 -b .bz189161
%patch16 -p1 -b .tcsegfault
%patch17 -p1 -b .setegid

%build
RPM_OPT_FLAGS="$RPM_OPT_FLAGS -DPROJECTROOT='\"/usr\"'"
%if %{DEBUGINFO}
export CFLAGS="$RPM_OPT_FLAGS"
%else
export CFLAGS=`echo $RPM_OPT_FLAGS | sed 's/-O2 -g/-g3 -gdwarf-2/g'`;
%endif
%configure --enable-luit \
           --enable-warnings \
           --enable-wide-chars \
           --with-utempter \
	   --enable-narrowproto \
	   --with-tty-group=tty \
	   --with-app-defaults=%{x11_app_defaults_dir} \
%if !%{_with_tek4014}
           --disable-tek4014 \
%endif
%if %{_with_256_color}
	   --enable-256-color \
%endif
%if %{enable_trace}
	   --enable-trace \
%endif
;
make

%install
rm -rf $RPM_BUILD_ROOT
%makeinstall appsdir=$RPM_BUILD_ROOT/%{x11_app_defaults_dir} apploaddir=%{x11_app_defaults_dir}
mkdir -p $RPM_BUILD_ROOT/%{_mandir}/man1
mv $RPM_BUILD_ROOT/%{_mandir}/*.1 $RPM_BUILD_ROOT/%{_mandir}/man1/
#gunzip < %SOURCE1 > ctlseqs.txt
#   ^- now shipped in upstream tarball
gunzip < %SOURCE2 > UnicodeData.txt
cp -fp %SOURCE3 16colors.txt
%if !%{DEBUGINFO}
/usr/lib/rpm/brp-compress
exit 0
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root)
%doc xterm.log.html ctlseqs.ms ctlseqs.txt UnicodeData.txt 16colors.txt README.i18n
%{_bindir}/resize
%{_bindir}/uxterm
%attr(2755,root,utempter) %{_bindir}/xterm
%{_mandir}/man1/resize.1*
%{_mandir}/man1/xterm.1*
%{x11_app_defaults_dir}/UXTerm
%{x11_app_defaults_dir}/XTerm
%{x11_app_defaults_dir}/XTerm-color

%changelog
* Wed May 16 2007 Miroslav Lichvar <mlichvar@redhat.com> 215-5.el5
- make xterm binary sgid utempter (#222847)

* Wed Jan 03 2007 Miroslav Lichvar <mlichvar@redhat.com> 215-4.el5
- use correct tty group (#220153)

* Mon Sep 04 2006 Miroslav Lichvar <mlichvar@redhat.com> 215-3.fc6
- fix segfault when /etc/termcap is missing (#201246)

* Wed Jul 26 2006 Mike A. Harris <mharris@redhat.com> 215-2.fc6
- Replace BuildRequires utempter with libutempter-devel
- Change BuildRoot tag to comply with Fedora packaging guidelines
- Use pkg-config to autodetect the location of the system app-defaults dir
- Add BuildRequires: pkgconfig

* Mon Jul 17 2006 Jason Vas Dias <jvdias@redhat.com> - 215-1.fc6
- Upgrade to upstream version 215

* Wed Jul 12 2006 Jesse Keating <jkeating@redhat.com> - 213-2.1
- rebuild

* Tue Jul 11 2006 Adam Jackson <ajackson@redhat.com> - 213-2.fc6
- Use correct dist tag in Release string.

* Wed May 31 2006 Jason Vas Dias <jvdias@redhat.com> - 213-1
- Upgrade to upstream version 213 (fixes bug 192627)
- fix bug 189161 : make -r/-rv do reverseVideo with or without
                   xterm*{fore,back}ground set
 
* Thu Apr 13 2006 Jason Vas Dias <jvdias@redhat.com> - 212-1
- Upgrade to upstream version 212
- fix bug 188031 : paths in man-page
 
* Wed Mar 29 2006 Jason Vas Dias <jvdias@redhat.com> - 211-4
- fix bug 186935: cursor GCs must be freed with XtReleaseGC

* Tue Mar 21 2006 Jason Vas Dias <jvdias@redhat.com> - 211-1
- Upgrade to upstream version 211 (fixes bug 186094).
- Enable new 'utf8Title' resource by default
 
* Tue Mar 07 2006 Jason Vas Dias <jvdias@redhat.com> - 209-4
- fix bug 183993: call set_cursor_gcs in ReverseVideo

* Wed Feb 22 2006 Jason Vas Dias <jvdias@redhat.com> - 209-2
- fix bug 182382: check for (VWindow(screen)!=0) in set_cursor_gcs
- further fix for bug 178302: allow *vt100*cursorColor to be same as fg

* Tue Feb 14 2006 Jason Vas Dias <jvdias@redhat.com> - 209-1
- Upgrade to upstream version 209 (fixes bug 180450)

* Fri Feb 10 2006 Jesse Keating <jkeating@redhat.com> - 208-1.2
- bump again for double-long bug on ppc(64)

* Tue Feb 07 2006 Jesse Keating <jkeating@redhat.com> - 208-1.1
- rebuilt for new gcc4.1 snapshot and glibc changes

* Tue Jan 17 2006 Jason Vas Dias<jvdias@redhat.com> - 208-1
- Upgrade to upstream version 208
- Allow root user to grab the console, even if /dev/console 
  not owned by root
- restore Red Hat '*VT100*scrollBar:1' default Xresource

* Wed Dec 21 2005 Jason Vas Dias<jvdias@redhat.com> - 207-10
- Fix bug 164210: tek4014 support should be enabled by default

* Wed Dec 14 2005 Jason Vas Dias<jvdias@redhat.com> - 207-8
- Fix bug 175684: compile with --enable-256-color
- Fix bug 155538 addenda - restore '*VT100*backarrowKey:0'

* Fri Dec 09 2005 Jesse Keating <jkeating@redhat.com>
- rebuilt

* Mon Nov 21 2005 Jason Vas Dias<jvdias@redhat.com> - 207-5
- fix bug 173703: remove reference to /usr/X11R6/bin/luit :
  PROJECTROOT should be /usr, not /usr/X11R6

* Thu Nov 18 2005 Jason Vas Dias<jvdias@redhat.com> - 207-4
- fix bug 173541: better fix for freetype configuration problem

* Mon Nov 14 2005 Jason Vas Dias<jvdias@redhat.com> - 207-1
- Upgrade to upstream version 207
- Fix app-defaults directory for modular X11

* Sun Nov 13 2005 Jeremy Katz <katzj@redhat.com> - 206-4
- rebuild for newer modular X

* Fri Nov 04 2005 Jason Vas Dias <jvdias@redhat.com> 206-1
- Upgrade to upstream version 206

* Wed Oct 12 2005 Jason Vas Dias <jvdias@redhat.com> 205-1
- Upgrade to upstream version 205 
  fixes bugs: 124421, 129146, 159562, 161894, 169347
 
* Sat Sep 24 2005 Mike A. Harris <mharris@redhat.com> 200-10
- Updated xterm-resources-redhat.patch to add "xterm*ttyModes: erase ^?"
  resource to fix bug (#155538,160354,163812,162549)
  
* Wed Sep 14 2005 Mike A. Harris <mharris@redhat.com> 200-9
- Updated xterm-resources-redhat.patch to remove utf8 resource which was
  added in the 200-7 build, as it was incorrectly set to 'true' instead
  of '1', and bug #138681 turned out to be a gdm bug instead of an xterm
  bug.  This fixes bug (#163568).
  
* Mon Aug 29 2005 Mike A. Harris <mharris@redhat.com> 200-8
- Added --disable-tek4014 to ./configure flags, to disable tek support
  for bug (#164210)

* Mon May 2 2005 Mike A. Harris <mharris@redhat.com> 200-7
- Updated xterm-resources-redhat.patch to enable xterm utf8 resource by
  default, as our default OS environment is UTF-8, for bug (#138681)

* Sat Apr 16 2005 Mike A. Harris <mharris@redhat.com> 200-6
- Added option to spec file to allow easy rebuilding with 256 color option
  for those who prefer this non-default behaviour (#103402)

* Tue Mar 8 2005 Soeren Sandmann <sandmann@redhat.com> 200-5
- Ported xterm-resources-redhat.patch to newer xterms. (#126855)

* Sun Mar 6 2005 Mike A. Harris <mharris@redhat.com> 200-4
- Added libtermcap-devel and utempter to BuildRequires
- Changed BuildRequires from XFree86-devel to xorg-x11-devel

* Sun Mar 6 2005 Mike A. Harris <mharris@redhat.com> 200-3
- Rebuild with gcc 4 for FC4 development

* Mon Feb 7 2005 Mike A. Harris <mharris@redhat.com> 200-2
- Removed chmod from prep, and updated comment to refect (#128341c12)

* Mon Feb 7 2005 Mike A. Harris <mharris@redhat.com> 200-1
- Updated main tarball to xterm-200 for FC4 devel
- Disabled xterm-179-ppc-fix-bug-101472.patch for now, to see if the problem
  occurs on ppc still or not.

* Fri Jul 13 2004 Mike A. Harris <mharris@redhat.com> 192-1
- Updated main tarball to xterm-192 for FC3 devel
- Resolved bugs #126569,127132

* Fri Jun 18 2004 Mike A. Harris <mharris@redhat.com> 191-1
- Updated main tarball to xterm-191 for FC3 devel
- Disabled xterm-resources-redhat.patch to see what if anything breaks, as
  it no longer applies cleanly.  Hopefully we can just ship stock xterm
  resources now, although I realize that is more likely to be a pie in the
  sky fantasy once the bug reports trickle in from this change.  ;o)
  
* Tue Jun 15 2004 Elliot Lee <sopwith@redhat.com> 179-8
- rebuilt

* Thu Jun  3 2004 Mike A. Harris <mharris@redhat.com> 179-7
- Rebuilt for FC3 devel

* Fri Feb 13 2004 Elliot Lee <sopwith@redhat.com> 179-6.EL
- rebuilt

* Mon Sep  8 2003 Mike A. Harris <mharris@redhat.com> 179-5.EL
- Rebuilt 179-5 for Taroon

* Mon Sep  8 2003 Mike A. Harris <mharris@redhat.com> 179-5
- Added xterm-179-ppc-fix-bug-101472.patch ifarch ppc ppc64 to fix bug (#101472)

* Wed Aug 27 2003 Bill Nottingham <notting@redhat.com> 179-4.1
- fix symlink
- rebuild

* Wed Aug 13 2003 Mike A. Harris <mharris@redhat.com> 179-3.EL
- Rebuilt for Taroon with symlink fixes.

* Wed Aug 13 2003 Mike A. Harris <mharris@redhat.com> 179-3
- Added symlink /usr/X11R6/bin/xterm pointing to _bindir/xterm so that apps
  and scripts which invoke xterm explicitly as /usr/X11R6/bin/xterm, will
  continue to work correctly without surprises (#101994)

* Wed Jun 04 2003 Elliot Lee <sopwith@redhat.com> 179-2.EL
- rebuilt

* Fri May 30 2003 Mike A. Harris <mharris@redhat.com> 179-1.EL
- Bump release to 1.EL for Red Hat Enterprise Linux build

* Mon May 26 2003 Mike A. Harris <mharris@redhat.com> 179-1
- Updated to upstream xterm 179
- [SECURITY] Added xterm-can-2003-0063.patch from XFree86 4.3.0-12 package
- Added Red Hat xterm-resources-redhat.patch from XFree86 4.3.0-12 package
- Added "chmod -R u+w *" after source is decompressed or else patches can not
  be applied due to upstream source being read only files
- Built xterm 179-1 in rawhide

* Mon May  5 2003 Mike A. Harris <mharris@redhat.com> 177-2.0.EL
- Bump release to 2.0.EL for Red Hat Enterprise Linux build

* Mon May  5 2003 Mike A. Harris <mharris@redhat.com> 177-2
- Build fix for lib64:  _x11datadir == /usr/X11R6/lib
- Another lib64 build fix:  xterm uses /usr/%%{_lib}/X11/app-defaults when it
  should be using an arch-neutral dir {_x11datadir}/X11/app-defaults instead

* Tue Apr 15 2003 Mike A. Harris <mharris@redhat.com> 177-1
- Call configure with "--enable-luit --enable-warnings --enable-wide-chars
  --with-utempter"
- Initial build.
